#include "editdialog.h"
#include "ui_editdialog.h"

EditDialog::EditDialog(QWidget *parent) :
    QDialog(parent),
    m_ui(new Ui::EditDialog)
{
    m_ui->setupUi(this);
}

EditDialog::~EditDialog()
{
    delete m_ui;
}

void EditDialog::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void EditDialog::setMovement(Movement* m)
{
    this->m=m;
    this->p=NULL;
    this->setWindowTitle("Movement edit");
    this->m_ui->titleEdit->setText(m->text(0));
    this->m_ui->pauseLabel->setVisible(false);
    this->m_ui->pauseSpin->setVisible(false);
}

void EditDialog::setPosition(Position* p)
{
    this->m=NULL;
    this->p=p;
    this->setWindowTitle("Position edit");
    this->m_ui->titleEdit->setText(p->text(0));
    this->m_ui->pauseSpin->setValue(p->text(1).toInt());
    this->m_ui->pauseLabel->setVisible(true);
    this->m_ui->pauseSpin->setVisible(true);
}

void EditDialog::on_buttonBox_accepted()
{
    if(p!=NULL){
        p->setText(0,m_ui->titleEdit->text());
        p->setText(1,QString::number(m_ui->pauseSpin->value()));
        Movement* mov=(Movement*)p->parent();
        mov->updateTiming();
    }else if(m!=NULL){
        m->setText(0,m_ui->titleEdit->text());
    };
}
