#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include <QModelIndex>
#include <QMouseEvent>

#include "servoframe.h"

namespace Ui
{
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

private:
    servoFrame* servo[32];
    int servoQty;
    int moveFlag;
    int actionFlag;
    int declineServoPos;
    QString filename;
    int modifiedFlag;
    QPoint startDrag;
    void updateTitle();
    bool readProject(QString fname);
    void saveProject(QString fname);
    void removeServo(int n);
    void updateServoPosOrDisable();

private slots:
    void on_treeWidget_doubleClicked(QModelIndex index);
    void on_delPosBtn_clicked();
    void on_addPosBtn_clicked();
    void on_delMoveBtn_clicked();
    void on_addMoveBtn_clicked();
    void on_treeWidget_itemSelectionChanged();
    void fileNew();
    void fileOpen();
    void fileSave();
    void fileSaveAs();
    void addServo();
    void mouseMoveEvent(QMouseEvent* event);
    void mousePressEvent(QMouseEvent* event);
    void mouseReleaseEvent(QMouseEvent* event);
    void servoChange(QString oldId, servoFrame* serv);

private:
    Ui::MainWindow *ui;
};

#endif // MAINWINDOW_H
