#include "position.h"

Position::Position()
{
}

QDomNode Position::prepareXmlBlock(QDomDocument doc)
{
    QDomElement p_xml = doc.createElement("position");
    QDomElement title_xml = doc.createElement("title");
    QDomText title_txt = doc.createTextNode(this->text(0));
    QDomElement pause_xml = doc.createElement("pause");
    QDomText pause_txt = doc.createTextNode(this->text(1));
    title_xml.appendChild(title_txt);
    pause_xml.appendChild(pause_txt);
    p_xml.appendChild(title_xml);
    p_xml.appendChild(pause_xml);
    for(int i=0; i<this->count(); i++)p_xml.appendChild(this->item(i)->prepareXmlBlock(doc));
    return p_xml;
}

QString Position::readXmlBlock(QDomNode node)
{
    if(node.childNodes().at(0).nodeName()!="title"){
        return "First child of some <position> is not <title>!";
    }else if(node.childNodes().at(1).nodeName()!="pause"){
        return "Second child of some <position> is not <pause>!";
    }else{
        this->setText(0,node.childNodes().at(0).childNodes().at(0).nodeValue());
        this->setText(1,node.childNodes().at(1).childNodes().at(0).nodeValue());
        for(int i=2; i<node.childNodes().count(); i++)
        {
            ServoPos* sp=new ServoPos();
            QString err=sp->readXmlBlock(node.childNodes().at(i));
            this->add(sp);
            if(err!="")return err;
        };
        return "";
    };
}

void Position::add(ServoPos* sp)
{
    positions.append(sp);
}

void Position::add(QString id, int pos)
{
    ServoPos* sp=new ServoPos();
    sp->setId(id);
    sp->setPos(pos);
    positions.append(sp);
}

int Position::count()
{
    return positions.count();
}

void Position::remove(int i)
{
    ServoPos* sp=positions.at(i);
    positions.removeAt(i);
    delete(sp);
}

ServoPos* Position::item(int i)
{
    return positions.at(i);
}
