#ifndef SERVOFRAME_H
#define SERVOFRAME_H

#include <QtGui/QFrame>
#include <QDomDocument>
#include <QDomNode>

namespace Ui {
    class servoFrame;
}

class servoFrame : public QFrame {
    Q_OBJECT
public:
    servoFrame(QWidget *parent = 0);
    ~servoFrame();
    QString id();
    int port();
    int pos();
    bool selected();
    void setSelected(bool sel);
    void setId(QString id);
    void setPort(int port);
    void setPos(int pos);
    void setLocation(int x,int y);
    void setLocation(QPoint p);
    QDomNode prepareXmlBlock(QDomDocument doc);
    QString readXmlBlock(QDomNode node);

protected:
    void changeEvent(QEvent *e);

signals:
    void onServoChange(QString oldId, servoFrame* servo);

private:
    Ui::servoFrame *m_ui;

private slots:
    void on_nameEdit_textChanged(QString );
    void on_selectedBox_toggled(bool checked);
    void on_positionSpin_valueChanged(int );
};

#endif // SERVOFRAME_H
