#include "servopos.h"

ServoPos::ServoPos()
{
    id_val="";
    pos_val=0;
}

QString ServoPos::id()
{
    return id_val;
}

int ServoPos::pos()
{
    return pos_val;
}

void ServoPos::setId(QString id)
{
    id_val=id;
}

void ServoPos::setPos(int pos)
{
    pos_val=pos;
}

QDomNode ServoPos::prepareXmlBlock(QDomDocument doc)
{
    QDomElement sp_xml = doc.createElement("servoPos");
    QDomElement id_xml = doc.createElement("id");
    QDomElement pos_xml = doc.createElement("pos");
    QDomText id_txt = doc.createTextNode(this->id());
    QDomText pos_txt = doc.createTextNode(QString::number(this->pos()));
    id_xml.appendChild(id_txt);
    pos_xml.appendChild(pos_txt);
    sp_xml.appendChild(id_xml);
    sp_xml.appendChild(pos_xml);
    return sp_xml;
}

QString ServoPos::readXmlBlock(QDomNode node)
{
    if(node.childNodes().at(0).nodeName()!="id"){
        return "First child of some <servoPos> is not <id>!";
    }else if(node.childNodes().at(1).nodeName()!="pos"){
        return "Second child of some <servoPos> is not <pos>!";
    }else{
        this->setId(node.childNodes().at(0).childNodes().at(0).nodeValue());
        this->setPos(node.childNodes().at(1).childNodes().at(0).nodeValue().toInt());
        return "";
    };
}
